%illustrates water filling
clear all, close all
sigma = 2e-17;  %-140 dBm/Hz, noise
%S*g/gap = 2e-13 for reaching 15 bits and 2e-17 for 1 bit
pmax = 2 * 2e-16; %power
gap = 1; %gap in linear scale
g = [1 1e-1] %channel gains
%perform waterfilling
[S,waterlevel,SNR]=ak_simplewaterfill(g,sigma,gap,pmax)
%
disp(['Optimum PSD:']);
S
%sanity check
disp(['Should be the same: ' num2str(sum(S)) ' and ' num2str(pmax)])
disp(['Waterlevel = ' num2str(waterlevel)]);
disp(['gap * (sigma./g) = '])
gap * (sigma./g)
%plot figure in linear scale
A=[gap * (sigma./g); S];
clf, bar(A','stacked')
xlabel('Tones (k)')
ylabel('Stacked: \Gamma\sigma/g and PSDs')
hold on
plot(1:length(S),waterlevel*ones(size(S)),'-X','markersize',16);
legend1 = legend('Inverse SNR','PSD')
set(legend1,'Position',[0.6403 0.1561 0.2644 0.1096]);
writeEPS('waterfill');
hold off