Apass=5; %maximum ripple at passband
Astop=80; %minimum attenuation at stopband
Fp=100; Wp=2*pi*Fp; %%%%%%%%% Lowpass Elliptic %%%%%%%%% 
Fr=120; Wr=2*pi*Fr;
[N, Wp] = ellipord(Wp, Wr, Apass, Astop, 's') %find order
[z,p,k]=ellip(N,Apass,Astop,Wp,'s'); %design filter
B=k*poly(z); A=poly(p); %convert zp to transfer function
[H,w]=freqs(B,A); %calculate frequency response
ak_plotFrequencyResponseAndMask(H,w,Apass,Astop,Wp,Wr,'lowpass');
writeEPS('lowpassElliptic');
Fr=100; Wr=2*pi*Fr; %%%%%%%%% Higpass Elliptic %%%%%%%%%
Fp=120; Wp=2*pi*Fp;
[N, Wp] = ellipord(Wp, Wr, Apass, Astop, 's') %find order
[z,p,k]=ellip(N,Apass,Astop,Wp,'high','s'); %design filter
B=k*poly(z); A=poly(p); %convert zp to transfer function
[H,w]=freqs(B,A); %calculate frequency response
ak_plotFrequencyResponseAndMask(H,w,Apass,Astop,Wp,Wr,...
    'highpass'); %plot
writeEPS('highpassElliptic');
Fr1=10; Wr1=2*pi*Fr1; %%%%%%%% Bandpass Elliptic %%%%%%%%
Fp1=20; Wp1=2*pi*Fp1;
Fp2=120; Wp2=2*pi*Fp2;
Fr2=140; Wr2=2*pi*Fr2;
[N,Wp]=ellipord([Wp1 Wp2],[Wr1 Wr2],Apass,Astop,'s')%order
[z,p,k]=ellip(N,Apass,Astop,Wp,'s');%design filter
B=k*poly(z); A=poly(p); %convert zp to transfer function
[H,w]=freqs(B,A); %calculate frequency response
ak_plotFrequencyResponseAndMask(H,w,Apass,Astop,Wp,...
    [Wr1 Wr2],'bandpass');
writeEPS('bandpassElliptic');
%%%%%%%%%%% Bandpass Butterworth %%%%%%%%%%%
[N, Wn]=buttord([Wp1 Wp2],[Wr1 Wr2],Apass,Astop,'s')%order
[z,p,k]=butter(N,Wn,'s'); %design Butterworth filter
B=k*poly(z); A=poly(p); %convert zp to transfer function
[H,w]=freqs(B,A); %calculate frequency response
ak_plotFrequencyResponseAndMask(H,w,Apass,Astop,Wp,...
    [Wr1 Wr2],'bandpass');
subplot(211); axis([1e-2 1e4 -150 0])
writeEPS('bandpassButterworth');