M=16; %modulation order, number of distinct symbols
N = 400000; % number of symbols
L=8; %oversampling factor
indices=floor(M*rand(1,N))+1; %random indices from [1, M]
alphabet=[-(M-1):2:M-1]; %symbols ...,-3,-1,1,3,5,7,...
M=alphabet(indices); %obtain M random symbols
m_upsampled=zeros(1,N*L); %pre-allocate space with zeros
m_upsampled(1:L:end)=M; %insert symbols, keep L-1 zeros in-between
p=ones(1,L); %shaping pulse is a square waveform
s=conv(m_upsampled,p); %convolve symbols with shaping pulse
Fs = 2*pi; %normalized sampling frequency
pm = mean(abs(alphabet).^2) / L; %upsampled signal power
NFFT = 4096; %number of FFT points
[Pem,w]=pwelch(s,hamming(NFFT),[],NFFT,Fs,'twosided');
p=fft(p,NFFT); %sampled DTFT (via FFT) of shaping pulse
Pth=pm*abs(p).^2; %theoretical expression for the PSD
plot(w/(2*pi),10*log10(Pth)); hold on; %plots in db
skip=30; %points to skip
plot(w(1:skip:end)/(2*pi),10*log10(2*pi*abs(Pem(1:skip:end))),'or');
legend('theoretical','estimated')
disp('powers:'), mean(s.^2), mean(Pth), mean(Pem)