N = 3000; %total number of signal samples
L = 4; %number of non-zero samples of h[n]
power_x = 600; %noise power in Watts
x=sqrt(power_x) * randn(1,N); %Gaussian white noise
h=ones(1,L); %shaping pulse with square waveform
y=conv(h,x); %filter signal x with filter
H=fft(h,4*N); %DTFT (sampled) of the impulse response
Sy_th=power_x*abs(H).^2; %PSD theoretical expression
M=256; %maximum lag chosen as M < N
[Ry,lags]=xcorr(y,M,'biased'); %estimating autocorrelation
Sy_corr=abs(fft(Ry)); %periodogram (PSD estimate) via xcorr
