h=transpose([-4 -3 -2]) %channel, column vector
M=length(h)-1; %dispersion of impulse respose
x=mseq(2,12); %maximum length sequence
alpha=sum(x.^2); %alpha is the value of R(0), a normalization factor
[R,lag]=xcorr(x); %autocorrelation, use stem(lag,R) to plot it
z2=conv(R,h)/alpha; %conceptually, this is what we would like to do
%in practice, the procedure is as follows:
y=conv(h,x); %input signal passes through the channel
%recall that xcorr(x) == conv(x,flipud(x))
z=conv(y,flipud(x))/alpha; %z is equal to z2
[maxOutput, maxIndex] = max(abs(z)); %find peak of output (R)
h_hat=z(maxIndex:maxIndex+M) %estimated channel
mse=mean((h-h_hat).^2) %error in the estimation