%Script cioffi_example431.m
%Example 4.3.1 - Page 305 - Rate-adaptive loading

h=[0.9 1] % H(z) = 0.9z + 1
N = 8;
sigma2 = 0.181; %No/2 PSD level
%gapdB = 0
gap = 1 %10^(gapdB / 10)  %db = 10 log10 (linear)
EpsXbar = 1;

% H(z) = 0.9z + 1 => H(n) = 1 + 0.9 exp (j w_n), where w_n=(2 pi n)/N
% H(n) = 1 + 0.9 exp (j 2 pi n / 8)
n = 0:N-1;

%using the expression itself
H = 1 + 0.9 * exp (j*2*pi*n./8);
mag = abs(H); %phase = angle(H)/pi*180

g = mag.^2 / sigma2

Nsubchannels = N; %start with all channels
%From Eq. (4.42) page 303
K = 1/Nsubchannels * (N*EpsXbar + sum( 1./g))
Epsn = K - 1./g

%Epsn for n=4 is negative, take it out
Nsubchannels=N-1
g(5)=[]
K = 1/Nsubchannels * (N*EpsXbar + sum( 1./g))
Epsn = K - 1./g

%found the solution
bnbar = 0.5 * log2(K * g)

n=1:7;
plot(n,Epsn,n,1./g,n,Epsn+1./g)
legend('Energy Epsn','Inverse SNR 1/g','Epsn+1./g (value of K)')
title('RA waterfilling')

Total_energy = sum(Epsn)
disp('Note that all 8 Joules of energy were used and the rate was maximized')

return
