%Script cioffi_example432.m
%Example 4.3.2 - Page 308 - Margin-adaptive loading
clear all
h=[0.9 1] % H(z) = 0.9z + 1
b = 8
N = 8;
sigma2 = 0.181; %No/2 PSD level
gapdB = 8.8
gap = 10^(gapdB / 10)  %db = 10 log10 (linear)
%EpsXbar = 1;

% H(z) = 0.9z + 1 => H(n) = 1 + 0.9 exp (j w_n), where w_n=(2 pi n)/N
% H(n) = 1 + 0.9 exp (j 2 pi n / 8)
n = 0:N-1;

%using the expression itself
H = 1 + 0.9 * exp (j*2*pi*n./8);
mag = abs(H); %phase = angle(H)/pi*180

g = mag.^2 / sigma2

Nsubchannels = N; %start with all channels
Kma = gap * (2^(2*b) / prod(g))^(1/Nsubchannels)
%From Eq. (4.64) page 306
Epsn_bar = Kma - gap./g  %energy per subdimension

%Epsn for n=4 is negative, take it out
Nsubchannels=N-1
g(5)=[]
Kma = gap * (2^(2*b) / prod(g))^(1/Nsubchannels)
Epsn_bar = Kma - gap./g %energy per subdimension

%take in account PAM and QAM subchannels
Epsn = [Epsn_bar(1) 2*Epsn_bar(2) 2*Epsn_bar(3) 2*Epsn_bar(4)]

%margin
margin_max = 8/sum(Epsn)
10*log10(margin_max)