function delta_s = getPowerLevels(n_power_levels, p_max_watts, min_power_dBmHz)
%reserve one level to 0 Watts, so use n_power_levels-1
%make each value x in delta_s to have its "partner" p_max - x
max_power_dBmHz = 10*log10(p_max_watts/1e-3)
if (max_power_dBmHz <= min_power_dBmHz) 
    error('Error: max_power_dBmHz <= min_power_dBmHz');
end
if 1
    %use linear spacing in dB domain
    if rem(n_power_levels,2) == 0
        %even
        N = (n_power_levels/2)+1;
    else
        %odd
        N = (n_power_levels+1)/2;
    end
    delta_s = linspace(min_power_dBmHz,max_power_dBmHz,N)
    %convert to Watts: dBm = 10 log10 (W/1e-3) and pre-append 0 Watts and
    delta_s(1)=[];
    delta_s(end)=[];
    delta_s = [(1e-3 * (10.^ (delta_s/10)))]
    delta_s = [delta_s, p_max_watts-delta_s]
    %include extrema values and also correct numerical errors
    delta_s = [0, delta_s, p_max_watts];
    delta_s = sort(delta_s); %because of the inclusion of p_max/2
    delta_s(end) = p_max_watts;
else
    %use linear spacing in Watts domain
    delta_s = linspace(3.1623e-006,0,n_power_levels-1);    
    delta_s = [0 delta_s];
end
