function [y,w]=magfft(x,N,isnormalized)
% function [y,w]=magfft(x,N,isnormalized)
%
%calculates the magnitude spectrum of x. 
%Uses an N-point FFT. If length(x) > N, uses N = length(x).
%Plots the FFT magnitude too.
%If isnormalized = 1, divides the FFT result by FFT length

if nargin < 2
   N = length(x)
end

if (length(x) > N)
   N=length(x);
end

delta=(2*pi)/N;
w=-pi:delta:pi-delta;
if isnormalized == 1
   y=fftshift(abs(fft(x,N))/N);
else   
   y=fftshift(abs(fft(x,N)));
end

plot(w,y);
xlabel('Frequency (radians)');
ylabel('Magnitude');