function plotConstellation(M,y)
% function plotConstellation(M,y)
%  plot constellation y with M symbols

scatterplot(y,1,0,'b.'); % Dots for points.
% Include text annotations that number the points in binary.
hold on; % Make sure the annotations go in the same figure.
annot = dec2bin([0:length(y)-1],log2(M));

%need to resize the axis such that the binary numbers fit
range = axis;
deltax = (range(2) - range(1))/(10*M);
axis([range(1)-deltax range(2)+3*deltax range(3) range(4)])

text(real(y)+deltax,imag(y),annot);
grid
hold off;