%Prova 4 - questao 3
%You can use both PAM and QAM subchannels
N = 4;
bauds = 20;

showPlots = 1;

totalPower_dBm = 10;
totalPower = 1e-3 * 10^(totalPower_dBm/10) %convert from dBm to Watts

noisePSD_dBm = -110;
noisePSD_N0div2 = 1e-3 * 10^(noisePSD_dBm/10) %convert from dBm to Watts

Pe = 1e-3; %target error probability
gap = 1/3 * qfuncinv(Pe/4)^2 %gap calculation
gap_dB = 10 * log10(gap) %convert linear to dB

%noise for one dimension (or subdimension)
sigma2 = noisePSD_N0div2;

ha=[10 4 0 2] %channel A
hb=[10 2 -8] %channel B
if showPlots == 1
    freqz(ha);
    title('Channel A frequency response (positive frequencies only)')
    pause
    freqz(hb);
    title('Channel B frequency response (positive frequencies only)')
    pause
end

%choose one
h = hb;

Hk = fft(h,N); %use FFT of length N to get channel frequency response
g = abs(Hk).^2

%take in account that QAM subchannels have dimension equal to 2:
g_secondDimension = g;
g_secondDimension(N/2+1)=[]; %take out Nyquist PAM channel
g_secondDimension(1)=[]; %take out DC PAM channel
g_onlyPAM = [g g_secondDimension];
%now do waterfilling: all PAMs are submitted to the same noise
[txPower,waterlevel,SNR]=ak_simplewaterfill(g_onlyPAM,sigma2,gap,totalPower);

%reorganize things, putting together 2 PAMs to create a QAM subchannel
%we know that all active PAM in g has its correspondent PAM in
%g_secondDimension with the same energy, so exclude g_secondDimension and
%multiply by 2 the power of QAM subchannels
powerPerTone = 2*txPower(1:N);
powerPerTone(1) = txPower(1); %keep power of PAM DC subchannel
powerPerTone(N/2+1) = txPower(N/2+1) %keep power of PAM Nyquist subchannel

%sanity check
if (sum(powerPerTone) - totalPower > 1e-15) 
    error('sum(powerPerTone) differs from totalPower!')
end

%reorganize the noise power taking in account PAM and QAM subchannels
noisePower = 2 * sigma2 * ones(size(powerPerTone));
noisePower(1) = sigma2; %keep power of PAM DC subchannel
noisePower(N/2+1) = sigma2; %keep power of PAM Nyquist subchannel

if showPlots == 1
    %plot waterfilling figure in linear scale for all subchannels as PAMs
    A=[gap * (noisePower./g);
        powerPerTone];
    bar(A','stacked')
    xlabel('Tones (k)')
    ylabel('Stacked: inverse SNR (\Gamma\sigma/g) and Tx power')
    title('Show subchannels as PAMs and QAMs')    
    pause
end

%recalculate the receiver SNR
SNR = (powerPerTone.* g) ./ (noisePower)
%for SNR and bits we are not going to use the negative subchannels
SNR = SNR(1:N/2+1);
SNRdB = 10*log10(SNR)

bitsPerDimension=0.5*log2(1 + SNR/gap);
bits = 2*bitsPerDimension; %valid for QAM subchannels
bits(1) = 0.5*log2(1 + SNR(1)/gap); %correct for PAM DC subchannel
bits(N/2+1) = 0.5*log2(1 + SNR(N/2+1)/gap); %correct for PAM Nyquist subchannel

%margin calculation (Eq. 4.7 in page 296 of Cioffi's notes):
lambda = (SNR/gap) ./ (2.^(2*bitsPerDimension) - 1)
lambda_dB = 10*log10(lambda)

rate = bauds * sum(bits)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Escolher bitloading e potencia
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
bits = [20 40 0]
%note that totalPower=0.01
p1 = 0.005
powerPerTone = [p1 (totalPower-p1)/2 0]
dimensionPerTone = [1 2 1];
bitsPerDimension = bits ./ dimensionPerTone;
noisePower = noisePower(1:3)
R = sum(bits)*bauds

%check if power exceeds total maximum
if (sum(powerPerTone)+powerPerTone(2)) > totalPower
    error('max power exceeded')
end

%channel A
g = abs(fft(ha,N)).^2; g = g(1:3);
SNR = (powerPerTone.* g) ./ (noisePower)
lambda = (SNR/gap) ./ (2.^(2*bitsPerDimension) - 1)

%channel B
g = abs(fft(hb,N)).^2; g = g(1:3);
SNR = (powerPerTone.* g) ./ (noisePower)
lambda = (SNR/gap) ./ (2.^(2*bitsPerDimension) - 1)
