Fs = 11025;   %define sampling rate (Hz)
fc = 1500; %cosine frequency (Hz)
numSamples = 1000; %number (integer) of samples
outputSignal=cos(2*pi*fc/Fs*(0:numSamples)); %signal sent to DAC
while 1 %infinite loop, stop with CTRL+C
    wavplay(outputSignal, Fs, 'async');  %playback via DAC
    inputSignal  = wavrecord(numSamples, Fs, 'int16'); %record (ADC)
    subplot(211), plot(inputSignal); %graph in time domain 
    subplot(212), psd(double(inputSignal)); %in frequency domain
    drawnow %Force the graphics to update immediately inside the loop
end